#if defined(UNICODE) && !defined(_UNICODE)
    #define _UNICODE
#elif defined(_UNICODE) && !defined(UNICODE)
    #define UNICODE
#endif

#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#include "win101.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */
    INITCOMMONCONTROLSEX iCCE;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 101",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           350,                 /* Ancho */
           80,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    iCCE.dwSize = sizeof(INITCOMMONCONTROLSEX);
    iCCE.dwICC = ICC_BAR_CLASSES;
    InitCommonControlsEx(&iCCE);

    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hFont;
    DWORD ip;
    BYTE campo1, campo2, campo3, campo4;
    int vacios;
    NMHDR *lpNmhdr;
    NMIPADDRESS *lpnmIpaddress;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(-14, 0, 0, 0, 0, FALSE, FALSE, FALSE, 1, 0, 0, 0, 0, ("Ms Shell Dlg"));
            CreateWindowEx(0, WC_IPADDRESS, NULL,
                WS_CHILD | WS_VISIBLE | WS_TABSTOP,
                80,10,160,20,
                hwnd, (HMENU)ID_IPADDRESS,
                hInstance, NULL);
            CreateWindowEx(0, "STATIC", "Direccin:", WS_CHILD | WS_VISIBLE | SS_SIMPLE,
                10,10,220,20, hwnd, (HMENU)(ET_IPADDRESS),
                hInstance, NULL);
            SendDlgItemMessage(hwnd, ID_IPADDRESS, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ET_IPADDRESS, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(FALSE, 0));
            SendDlgItemMessage(hwnd, ID_IPADDRESS, IPM_SETADDRESS, 0, (LPARAM)MAKEIPADDRESS(127,0,0,1));
            SendDlgItemMessage(hwnd, ID_IPADDRESS, IPM_CLEARADDRESS, 0, 0);
            SendDlgItemMessage(hwnd, ID_IPADDRESS, IPM_SETFOCUS, 2, 0);
            SendDlgItemMessage(hwnd, ID_IPADDRESS, IPM_SETRANGE, 0, MAKEIPRANGE(20,40));
            break;
        case WM_NOTIFY:
            lpNmhdr = (NMHDR*)lParam;
            switch(lpNmhdr->code) {
                case IPN_FIELDCHANGED:
                    lpnmIpaddress = (NMIPADDRESS*)lParam;
                    if(lpnmIpaddress->iField == 1) {
                        if(lpnmIpaddress->iValue < 20) lpnmIpaddress->iValue = 22;
                        if(lpnmIpaddress->iValue > 40) lpnmIpaddress->iValue = 38;
                    }
                    if(lpnmIpaddress->iField == 2) {
                        if(lpnmIpaddress->iValue != 15 && lpnmIpaddress->iValue != 25) lpnmIpaddress->iValue = 15;
                    }
                    break;
            }
            break;
        case WM_DESTROY:
            vacios = SendDlgItemMessage(hwnd, ID_IPADDRESS, IPM_GETADDRESS, 0, (LPARAM)&ip);
            campo1 = FIRST_IPADDRESS(ip);
            campo2 = SECOND_IPADDRESS(ip);
            campo3 = THIRD_IPADDRESS(ip);
            campo4 = FOURTH_IPADDRESS(ip);
            DeleteObject(hFont);
            PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
            break;
        default:                  /* para los mensajes de los que no nos ocupamos */
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
